<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit( 'Permission Denied' );
}

if ( defined( 'ENV' ) and ENV == true ) {
	ini_set( 'display_errors', 1 );
	ini_set( 'display_startup_errors', 1 );
	error_reporting( E_ALL );
}

if ( ! isset( $_POST['security'] ) || ! wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['security'] ) ), 'exportfeed_etsy_cpf' ) ) {
	return;
}

if ( ! current_user_can( 'administrator' ) && ! current_user_can( 'author' ) ) {
	return;
}

global $wpdb;
$table = $wpdb->prefix . 'etcpf_settings';

$shipping_table = $wpdb->prefix . 'etcpf_shipping_template';
$wpdb->query( $wpdb->prepare( "TRUNCATE TABLE $shipping_table" ) );

if ( isset( $_POST['data'] ) && is_array( $_POST['data'] ) && count( $_POST['data'] ) > 0 ) {
	foreach ( map_deep( wp_unslash( $_POST['data'] ), 'sanitize_text_field' ) as $key => $item ) {
		etcpf_update_etsy_settings( $key, $item );
	}

	echo json_encode(
		array(
			'status'  => 'ok',
			'success' => true,
			'error'   => false,
		)
	);
} else {
	echo json_encode(
		array(
			'status'  => 'failed',
			'success' => false,
			'error'   => $e,
		)
	);
}

