<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly
if ( ! is_admin() ) {
	die( 'Permission Denied!' );
}
require_once ETCPF_PATH . '/core/classes/etsyclient.php';

if ( ! isset( $_POST['security'] ) || ! wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['security'] ) ), 'exportfeed_etsy_cpf' )) {
	return;
}

if ( ! current_user_can( 'administrator' ) && ! current_user_can( 'author' ) ) {
	return;
}

global $wpdb;

$data                         = array();
$res                          = array();
$res['success']               = false;
$res['btn']                   = '';
$listing_id                   = isset( $_REQUEST['listing_id'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['listing_id'] ) ) : '';
$id_                          = isset( $_REQUEST['id'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['id'] ) ) : '';
$data['who_made']             = isset( $_REQUEST['who_made'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['who_made'] ) ) : '';
$data['when_made']            = isset( $_REQUEST['when_made'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['when_made'] ) ) : '';
$data['state']                = isset( $_REQUEST['state'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['state'] ) ) : '';
$data['shipping_template_id'] = isset( $_REQUEST['shipping_template_id'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['shipping_template_id'] ) ) : '';
$data['uploaded']             = 0;

update_option( 'etcpf_update_status', 'Initializing' );

$tbl    = $wpdb->prefix . 'etcpf_tmp_etsy_listing';
$update = $wpdb->update( $tbl, $data, array( 'listing_id' => $listing_id ) );

if ( $update ) {
	$etsy = new ETCPF_Etsy();

	$res['success'] = true;
	update_option( 'etcpf_update_status', 'Connect to etsy...' );

	$sql  = $wpdb->prepare( "SELECT * FROM $tbl WHERE id = %d", array( $id_ ) );
	$item = $wpdb->get_row( $sql, ARRAY_A );

	update_option( 'etcpf_update_status', 'Uploading to Etsy ... ' );
	$upload = $etsy->startUpload( $item );
	if ( ( is_string( $upload ) && ( is_object( json_decode( $upload ) ) || is_array( json_decode( $upload ) ) ) ) ) {
		$upload                       = json_decode( $upload );
		$uploaded_data                = $upload->results[0];
		$data                         = array();
		$data['listing_id']           = $uploaded_data->listing_id;
		$data['shop_id']              = $uploaded_data->user_id;
		$data['shipping_template_id'] = $uploaded_data->shipping_template_id;
		$data['uploaded']             = 1;
		$data['result']               = '';
		$data['last_updated']         = date( 'Y-m-d H:i:s' );

		$etsy->updateUploadData( $data, $item['id'] );
		$etsy->uploadImage( $data['listing_id'], $item['image'] );
		update_option( 'etcpf_update_status', 'Completed.' );

		$res['msg'] = '<span style="color:green">' . $item['title'] . ' is updated in Etsy.</span>';
	} else {
		$res['msg']     = '<span style="color:red">' . $upload . '</span>';
		$res['success'] = false;
	}
}
echo json_encode( $res );
die;
