<?php

class Order_FulFillment {

	public function withTrackingDetails( $url, $tracking_code, $carrier_name ): bool {
		$response = wp_remote_post(
			$url,
			array(
				'timeout'     => 120,
				'redirection' => 5,
				'blocking'    => true,
				'headers'     => array(
					'Content-Type'  => 'application/json',
					'Expect'        => '',
					'x-api-key'     => get_option( 'etcpf_api_key' ),
					'Authorization' => 'Bearer ' . get_option( 'etcpf_oauth_token' )
				),
				'body'        => json_encode( array(
						'tracking_code' => $tracking_code,
						'carrier_name'  => $carrier_name,
						'send_bcc'      => true
					)
				)
			) );

		if ( wp_remote_retrieve_response_code( $response ) !== 200 ) {
			return false;
		}

		return true;

	}

	public function withoutTrackingDetails( $url ): bool {
		$response = wp_remote_post(
			$url,
			array(
				'timeout'     => 120,
				'redirection' => 5,
				'blocking'    => true,
				'headers'     => array(
					'Content-Type'  => 'application/json',
					'Expect'        => '',
					'x-api-key'     => get_option( 'etcpf_api_key' ),
					'Authorization' => 'Bearer ' . get_option( 'etcpf_oauth_token' )
				)
			) );

		if ( wp_remote_retrieve_response_code( $response ) !== 200 ) {
			return false;
		}

		return true;


	}

}