<?php
	$iconurl = plugins_url( '/../../../images/exf-sm-logo.png', __FILE__ );
?>
<div class="etcpf_card etcpf_card_sticky etcpf_card_sticky--header">
	<div class="etcpf_card_body">
		<div class="etcpf_logo_wrapper">
			<a target="_blank" href="http://www.exportfeed.com">
				<img class="exf-logo-style" src='<?php echo esc_url( $iconurl ); ?>' alt="shopping cart logo">
			</a>
			<div class="d-flex ai-c flex-wrap">
				<span>
					Version: <?php echo esc_html( ETCPF_PLUGIN_VERSION ) . etcpf_version(); ?> &nbsp;&nbsp;&nbsp;&nbsp;
				</span>
				<button type="button" class="btn btn-primary btn-sm" onclick="window.open('<?php echo esc_url( 'https://www.exportfeed.com/contact/' ); ?>', '_blank');">
					<?php echo esc_html__( 'Contact Support', 'etsy-exportfeed-strings' ); ?>
				</button>
			</div>
		</div>
	</div>
</div>
<div class="etcpf-upload-block">
	<div class='etcpf_page_heading'>
		<h3>
			Etsy Variation Profiling
		</h3>
	</div>

	<form id="regForm" action="" method="post">
		<div class="draggable_section">
			<div class="divider personal_info col-md-8">
				<div class="form-group col-md-12 mt-2">
					<label class="col-md-3" for="profile_name">Profile Name</label>
					<input class="col-md-9" type="text" name="profile_name" value="" required
						   placeholder="Enter identifiable name for this variation profile.">
				</div>
				<div class="form-group col-md-12 mt-2">
					<label class="col-md-3" for="profile_description">Attributes Separator: </label>
					<input type="text" id="select-separator" name="attribute-seperator" value=""
						   placeholder="Enter the attribute seperator for eg: - or | or : etc">
				</div>
				<div class="container-table col-md-12 mt-2">
					<label class="col-md-3" for="name">Variations Attributes: </label>
					<form class="col-md-9" method="post">
						<select id="select-display">
							<option value="0">Select attributes for profiling</option>
							<?php
							foreach ( $product_attributes as $key => $value ) {
								?>
								<option id="attribute-selection-option-<?php echo esc_attr( $value ); ?>"
										value="<?php echo esc_attr( $value ); ?>"><?php echo esc_attr( $value ); ?></option>
							<?php } ?>
						</select>

					</form>
					<table class="table wp-list-table widefat fixed striped ui-sortable col-md-offset-3" id="tablelist"
						   style="display: none; width: 75%; float: right;">
						<thead>
						<tr>
							<th></th>
							<th>Prefix</th>
							<th>Attribute</th>
							<th>Suffix</th>
							<th>Remove</th>
						</tr>
						</thead>
						<tbody style="overflow: paged-y;">

						</tbody>
					</table>
				</div>
				<input id="sorted-attribute" type="hidden" name="sorted_attributes"
					   value="">
			</div>
			<?php
			if ( isset( $product_attributes ) && count( $product_attributes ) > 0 ) {
				$attributes = array_values( $product_attributes );
				$seperator  = etcpf_get_etsy_settings( 'variation_seperation' );
				?>
				<div class="variation_right hidden col-md-4">
					<div class="variation-selection-info-div">
						Attributes are added on the table based on your selection. You can remove unnecessary attributes
						from the table and also move the attribute rows up and down to sort the attributes.
					</div>

					<table class="tbl_variation_right ">
						<thead id="variation-head">
						<tr>
							<th>
								Variation attribute Order
							</th>
						</tr>
						</thead>
						<tbody id="variation-body"></tbody>
						<thead id="result-head">
						<tr>
							<th>Result</th>
						</tr>
						</thead>
						<tbody id="result-body">
						</tbody>
					</table>
				</div>
			<?php } ?>
			<?php wp_nonce_field( 'exportfeed_etsy', 'exportfeed_etsy_cpf' ); ?>
			<div class="form-group col-md-10">
				<input id="profile-submitter" class="col-md-2" type="submit" name="Submit" value="submit">
			</div>
		</div>
	</form>
</div>
 
<?php
	wp_register_script( 'etsy-export-feed-add-profile', plugins_url( '../../../js/profile/add_profile.js', __FILE__ ), array( 'jquery' ), ETCPF_PLUGIN_VERSION );
	wp_enqueue_script( 'etsy-export-feed-add-profile' );
?>
