<?php
	$iconurl           = plugins_url( '/../../../images/exf-sm-logo.png', __FILE__ );
	$etcpf_license_key = get_option( 'etcpf_licensekey' );
?>
<div class="etcpf_card etcpf_card_sticky etcpf_card_sticky--header">
	<div class="etcpf_card_body">
		<div class="etcpf_logo_wrapper">
			<a target="_blank" href="http://www.exportfeed.com">
				<img class="exf-logo-style" src='<?php echo esc_url( $iconurl ); ?>' alt="shopping cart logo">
			</a>
			<div class="d-flex ai-c flex-wrap">
				<span>
					Version: <?php echo esc_html( ETCPF_PLUGIN_VERSION ) . etcpf_version(); ?> &nbsp;&nbsp;&nbsp;&nbsp;
				</span>
				<button type="button" class="btn btn-primary btn-sm" onclick="window.open('<?php echo esc_url( 'https://www.exportfeed.com/contact/' ); ?>', '_blank');">
					<?php echo esc_html__( 'Contact Support', 'etsy-exportfeed-strings' ); ?>
				</button>
			</div>
		</div>
	</div>
</div>
<div style="display: none;" id="ajax-loader-cat-import"></div>
	<div class='etcpf_page_heading'>
		<h4 class="mb-3">
			Etsy Listing Configuration
		</h4>
	</div>
<div id="poststuff">

	<form id="settings-form">

		<div id="post-body" class="metabox-holder columns-2">

			<div id="postbox-container-3" class="postbox-container" style="width: 100%;">

				<div class="meta-box-sortables ui-sortable">
					<div class="postbox" id="Product-management-box">
						<div class="inside">

								<?php
								if ( $etsy_configuration ) {

									foreach ( $etsy_configuration as $key => $value ) {
										?>

										<?php if ( is_array( $value ) && count( $value ) > 0 ) { ?>
											<div class="row mb-3" >

												<label for="edtLicenseKey" class="col-sm-4 col-form-label">
													<?php
													if ( $key == 'is_supply' ) {
														echo 'Is a Supply or Finished Product ?';
													} elseif ( $key == 'who_made_it' ) {
														echo esc_html( ucfirst( str_replace( '_', ' ', $key ) ) ) . ' ?';
													} elseif ( $key == 'when_made' ) {
														echo 'When was it made ?';
													} elseif ( $key == 'etsy_api_limit' ) {
														echo 'Etsy API Limit <p style="font-size: 10px;">Note: For larger product quantities, <br> you may need to request Etsy to increase API limit for your account</p>';
													} else {
														echo esc_html( ucfirst( str_replace( '_', ' ', $key ) ) );
													}
													?>
												</label>

												<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8">
													<div class="d-flex flex-wrap flex-lg-nowrap row g-3">
														<div class=" col-10">
															<select class="form-control" name="<?php echo esc_html( $key ); ?>"
																id="etcpf_<?php echo esc_html( $key ); ?>">
																<option value=""> Choose One</option>
																<?php foreach ( $value as $k => $item ) { ?>
																	<option 
																	<?php
																	if ( etcpf_get_etsy_settings( $key ) == $item ) {
																		echo 'selected';}
																	?>
																	value="<?php echo esc_attr( $item ); ?>"><?php echo esc_attr( $k ); ?></option>
																<?php } ?>
															</select>
														</div>
													
														<?php if ( $key == 'shop_language' ) { ?>
														<div class="col-auto">
															<input type="button" name="etsy-language-sync-button" class="btn btn-primary btn-sm" value="sync current language">

														</div>
														<?php } ?>
													</div>
													
												</div>												

											</div>

										<?php } ?>

										<?php
									}
									?>
									<div class="row mb-3">
										<div class="col-sm-4">
											<label for="edtLicenseKey" class="col-form-label">
												License Key
											</label>
										</div>
										<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8">
											<div class="d-flex flex-wrap flex-lg-nowrap row">
												<div class="col-10">
													
													<input class="form-control" type="text" name="license_key" id="edtLicenseKey" value=""
													placeholder="Enter full license key"/>
													<div id="etcpf_invalid_license_message_div" style="display: none;">
														<p id="etcpf_invalid_license_message_content" style="font-size: 10px; color: #f00;"></p>
													</div>
													<p class="description">Click here to get the license key <a href="http://shop.exportfeed.com/cart.php?gid=8" target="_blank"> License key</a>.</p>
												</div>
												<div class="col-auto">
													<button class="btn btn-primary btn-sm" id="btn--license-apply" type="submit" onclick="etcpf_submitLicenseKey('etcpf_licensekey')">	
														<div>
															<span>Apply key</span>
														</div>
													</button>
												</div>
											</div>
										</div>	
									</div>
									<?php
								}
								?>


						</div>
					</div>

				</div>

			</div>

		</div>


		<div id="post-body" class="metabox-holder columns-2">

			<div id="postbox-container-3" class="postbox-container" style="width: 100%;">

				<div class="meta-box-sortables ui-sortable">

					<div class="postbox" id="Product-management-box">
						<h4 class="mb-4">
							Etsy Sync Settings (This settings allow which product attributes should be udated when inventory sync is performed)
						</h4>
						<div class="inside">


								<?php
								foreach ( $exception_setting as $key => $value ) {
									if ( $value !== 'wooImage' ) {
										?>
									<div class="row">
										<label for="edtLicenseKey" class="col-sm-4 col-form-label">
											<?php echo esc_html( ucfirst( $value ) ); ?>
										</label>

										<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8">
											<input type="hidden" name="<?php echo esc_html( $value ) . '_sync'; ?>" value="no">
											<div class="form-check">
												<input type="checkbox"
													name="<?php echo esc_html( $value ); ?>_sync"
													<?php
													if ( etcpf_get_etsy_settings( $value . '_sync' ) == 'yes' ) {
														echo 'checked';}
													?>
													id="etcpf-sync-<?php echo esc_attr( $value ); ?>"
													class="form-check-input" value="yes">
												<label class="form-check-label" for="<?php echo esc_attr( $value ); ?>">
													Check if you want to sync WooCommerce product
													<b><?php echo esc_attr( $value ); ?></b> with etsy item <b><?php echo esc_attr( $value ); ?></b>
												</label>
											</div>
										</div>

									</div>
										<?php
									} else {
										?>
									<div class="row">
										<label for="edtLicenseKey" class="col-sm-4 col-form-label">
											Sync images on product update
										</label>
										<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8">
											<input type="hidden" name="<?php echo esc_html( $value ) . '_sync'; ?>" value="no">
											<div class="form-check">
												<input type="checkbox"
													name="<?php echo esc_html( $value ); ?>_sync"
													<?php
													if ( etcpf_get_etsy_settings( $value . '_sync' ) == 'yes' && etcpf_get_etsy_settings( 'images_sync' ) == 'yes' ) {
														echo 'checked';
													}
													?>
													id="etcpf-sync-<?php echo esc_attr( $value ); ?>"
													class="form-check-input" value="yes">
												<label class="form-check-label" for="<?php echo esc_attr( $value ); ?>">
													Check if you want to sync WooCommerce product
													<b>images</b> with etsy when WooCommerce product is updated
												</label>
											</div>
										</div>

									</div>
										<?php
									}
								}
								?>



						</div>
					</div>

				</div>

			</div>

		</div>

		<div id="post-body" class="metabox-holder columns-2">

			<div id="postbox-container-3" class="postbox-container" style="width: 100%;">

				<div class="meta-box-sortables ui-sortable">

					<div class="postbox" id="Product-management-box">
						<h4 class="hndle">
							<span>Feed Management</span>
						</h4>
						<div class="inside">
								<?php
								foreach ( $cron_settings as $key => $value ) {
									if ( 'order_fetch_interval' === $key ) {
										continue;
									}
									?>
									<div class="row">
										<label class="col-sm-4 col-form-label">
											<?php echo esc_html( ucfirst( str_replace( '_', ' ', $key ) ) ); ?>
										</label>

										<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8 g-3">

											<select class="form-control" name="<?php echo esc_attr( $key ); ?>"
													id="etcpf_<?php echo esc_attr( $key ); ?>">
												<option value=""> Choose One</option>
												<option value="">--------------------------------------</option>
												<?php foreach ( $value as $k => $item ) { ?>
													<option 
													<?php
													if ( etcpf_get_etsy_settings( $key ) == $k ) {
														echo 'selected';}
													?>
													 value="<?php echo esc_attr( $k ); ?>"><?php echo esc_attr( $item ); ?></option>
												<?php } ?>
											</select>

										</div>

									</div>
								<?php } ?>



						</div>
					</div>

				</div>

			</div>

		</div>

		<div id="post-body" class="metabox-holder columns-2">

			<div id="postbox-container-3" class="postbox-container" style="width: 100%;">

				<div class="meta-box-sortables ui-sortable">

					<div class="postbox" id="Product-management-box">
						<h4 class="hndle">
							<span>Order Management</span>
						</h4>
						<div class="inside">
									<div class="row">
										<label class="col-sm-4 col-form-label">
											Sync Etsy's Order with WooCommerce's Order
										</label>
										<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8">
											<input type="hidden" name="woo_order_page_sync" value="no">
											<div class="form-check">
												<input type="checkbox" name="woo_order_page_sync"
												id="woo_order_page_sync"
												class="form-check-input" 
												<?php
												if ( etcpf_get_etsy_settings( 'woo_order_page_sync' ) == 'yes' ) {
													echo 'checked';}
													?>
												value="yes" >
												<label class="form-check-label" for="etcpf_woo_order_page_sync">Create order in WooCommerce's Order page when SKU matches</label>
											</div>
										</div>
									</div>

									<div class="row">
										<label class="col-sm-4 col-form-label">
											Sync Inventory
										</label>
										<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8">
											<input type="hidden" name="sync_inventory" value="no">
											<div class="form-check">
												<input type="checkbox" name="sync_inventory"
												id="etcpf_sync_inventory"
												class="form-check-input" 
												<?php
												if ( etcpf_get_etsy_settings( 'sync_inventory' ) == 'yes' ) {
													echo 'checked';}
													?>
												value="yes" >
												<label class="form-check-label" for="etcpf_sync_inventory">Reduce WooCommerce inventory when new order arrives</label>
											</div>
										</div>
									</div>
									<div class="row">
										<label class="col-sm-4 col-form-label">
											Reduce Parent Inventory
										</label>
										<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8">
											<input type="hidden" name="reduce_parent_inventory" value="no">
											<div class="form-check">
												<input type="checkbox" name="reduce_parent_inventory"
												id="etcpf_sync_inventory_from_parent"
												class="form-check-input" 
												<?php
													if ( etcpf_get_etsy_settings( 'reduce_parent_inventory' ) == 'yes' ) {
														echo 'checked';}
														?>
													value="yes" >
												<label class="form-check-label" for="etcpf_sync_inventory_from_parent">Reduce parent inventory if stock management not set in variations</label>
											</div>
										</div>
									</div>
								<?php
								foreach ( $cron_settings as $key => $value ) {
									if ( 'order_fetch_interval' !== $key ) {
										continue;
									}
									?>
									<div class="row">
										<label class="col-sm-4 col-form-label">
											<?php echo esc_html( ucfirst( str_replace( '_', ' ', $key ) ) ); ?>
										</label>

										<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8 g-3">

											<select class="form-control" name="<?php echo esc_attr( $key ); ?>"
													id="etcpf_<?php echo esc_attr( $key ); ?>">
											<?php
											foreach ( $value as $k => $item ) {
												if ( 'monthly' === $k ) {
													continue;
												}
												?>
													<option 
													<?php
													if ( etcpf_get_etsy_settings( $key ) == $k ) {
														echo 'selected';}
													?>
													 value="<?php echo esc_attr( $k ); ?>"><?php echo esc_attr( $item ); ?></option>
												<?php } ?>
											</select>

										</div>

									</div>
								<?php } ?>



						</div>
					</div>

				</div>

			</div>

		</div>

		<div id="post-body" class="metabox-holder columns-2">

			<div id="postbox-container-3" class="postbox-container" style="width: 100%;">

				<div class="meta-box-sortables ui-sortable">

					<div class="postbox" id="Product-management-box">
						<h4 class="hndle"><span>Product Management</span></h4>
						<div class="inside">

								<div class="row">
									<label class="col-sm-4 col-form-label">
										Stock Management
									</label>
									<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8">
										<input type="hidden" name="stock_managed" value="no">
										<div class="form-check">
											<input type="checkbox" name="stock_managed"
												id="wpla_permissions_administrator_manage_amazon_listings"
												class="form-check-input" 
												<?php
													if ( etcpf_get_etsy_settings( 'stock_managed' ) == 'yes' ) {
														echo 'checked';}
													?>
													value="yes" >
											<label class="form-check-label" for="wpla_permissions_administrator_manage_amazon_listings">Is stock managed
											? </label>
										</div>
									</div>
								</div>

								<div class="row">
									<label class="col-sm-4 col-form-label">
										Default stock quantity
										<p style="font-size: 10px;">Note: For Unmanaged Stock products.</p>
									</label>
									<div class="col-md-8 col-lg-6 col-xl-6 col-sm-8 g-3">
										<input type="number" name="default_stock_quantity"
											   id="etcpf_default_stock_quantity" class="form-control"
											   value="<?php echo esc_html( etcpf_get_etsy_settings( 'default_stock_quantity' ) ); ?>" placeholder="more than 0 & less than 999" min="1">
									</div>
								</div>


						</div>
					</div>

				</div>

			</div>

		</div>

		<div>
			<input class="btn btn-primary mt-3" type="button" name="submit" value="Save Settings">
		</div>
	</form>

</div>
<script>
	jQuery('[name="submit"]').click(function (e) {
		e.preventDefault();
		let formData = jQuery('#settings-form').serializeArray();
		let payload = {
			action: 'exportfeed_etsy',
			feedpath: ETCPF.cmdsettingsUpdate,
			security: ETCPF.ETCPF_nonce,
			perform: 'etcpf_update_etsy_settings',
			formData: formData,
		};
		jQuery('#ajax-loader-cat-import').show();
		etcpf_globalAjax(this, payload, function (error, data) {
			if (error) {
				console.log(error);
			} else {
				console.log(data)
			}
			jQuery('#ajax-loader-cat-import').hide();
			location.reload();
		});
	});

	jQuery('[name="etsy-language-sync-button"]').on('click', function (event) {
		let payload = {
			action: 'exportfeed_etsy',
			feedpath: ETCPF.cmdlanguageUpdate,
			security: ETCPF.ETCPF_nonce,
			perform: 'update_etsy_language',
		};
		jQuery('#ajax-loader-cat-import').show();
		etcpf_globalAjax(this, payload, function (error, data) {
			if (error) {
				console.log(error);
			} else {
				location.reload();
			}
			jQuery('#ajax-loader-cat-import').hide();
		});
	});

	window.addEventListener('load', function () {
		if (jQuery("#etcpf-sync-images").is(":not(:checked)")) {
			jQuery("#etcpf-sync-wooImage").attr("disabled", true);
		}

		if (jQuery("#etcpf_sync_inventory").is(":not(:checked)")) {
			jQuery("#etcpf_sync_inventory_from_parent").attr("disabled", true);
		}
	});

	jQuery("#etcpf-sync-images").click(function () {
		if (jQuery("#etcpf-sync-images").is(":checked")) {
			jQuery("#etcpf-sync-wooImage").attr("disabled", false);
		} else {
			jQuery("#etcpf-sync-wooImage").attr("checked", false);
			jQuery("#etcpf-sync-wooImage").attr("disabled", true);
		}
	});

	jQuery("#etcpf_sync_inventory").click(function () {
		if (jQuery("#etcpf_sync_inventory").is(":checked")) {
			jQuery("#etcpf_sync_inventory_from_parent").attr("disabled", false);
		} else {
			jQuery("#etcpf-sync-wooImage").attr("checked", false);
			jQuery("#etcpf_sync_inventory_from_parent").attr("disabled", true);
		}
	});	
</script>
