<?php
$login_url             = get_option( 'etcpf_login_url' );
$token_secret          = get_option( 'etcpf_oauth_token_secret' );
$stage                 = get_option( 'etcpf_stage' );
$url                   = '#';
$display               = 'display:block';
$token                 = false;
$etcpf_hide_setup_step = false;

if ( ! isset( $_POST['security'] ) || ! wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['security'] ) ), 'exportfeed_etsy_cpf' ) ) {
	if ( isset( $_GET['oauth_token'] ) && isset( $_GET['oauth_verifier'] ) && isset( $_GET['stage'] ) ) {
		$etcpf_hide_setup_step = true;
	}
}

if ( $login_url ) {
	// $display = 'display:block';
	$url = $login_url;
}

if ( strlen( $token_secret ) > 0 ) {
	$token = true;
	// $display = 'display:block';
}
global $wpdb;
$table_count     = $wpdb->prefix . 'etcpf_etsy_product_count';
$check           = $wpdb->get_row(
	$wpdb->prepare( "SELECT * FROM $table_count WHERE id=%d", array( 1 ) )
);
$table_etsy_sync = $wpdb->prefix . 'etcpf_etsy_sync';
$active_count    = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM $table_etsy_sync where state=%s", 'active' ) );
$draft_count     = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM $table_etsy_sync where state=%s", 'draft' ) );
$inactive_count  = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM $table_etsy_sync where state=%s", 'edit' ) );

if ( $check ) {
	$active   = $check->active;
	$draft    = $check->draft;
	$inactive = $check->inactive;
} else {
	$active   = 0;
	$draft    = 0;
	$inactive = 0;
}
$total_active   = max( $active - $active_count, 0 );
$total_draft    = max( $draft - $draft_count, 0 );
$total_inactive = max( $inactive - $inactive_count, 0 );

?>

<div style="display: none;" id="ajax-loader-cat-import">
	<div id="gif-message-span-for-more-than-one-feed"></div>
	<span id="gif-message-span"></span>
</div>
<div class="wrap" style="margin:0">
	<?php 
		if (!function_exists('str_contains')) {
			function str_contains($haystack, $needle) {
				return $needle !== '' && mb_strpos($haystack, $needle) !== false;
			}
		} 
		if ( isset( $cpf_shop['error'] ) && ! str_contains( $cpf_shop['error'], 'Connect with your Etsy shop first' ) ) : ?>
		<div id="etcpf_etsy_shop" class="updated settings-errors">
			<p><?php echo esc_html( $cpf_shop['error'] ); ?></p>
		</div>
	<?php endif; ?>

	<div id="poststuff"  style="padding: 20px 0">
		<div id="post-body" class="metabox-holder">
			<div id="postbox-container-1" class="postbox-container instruction-step">
				<div class="etcpf_setup_card etcpf_setup_card--center d-none" id="etcpf">
					<h4 class="etcpf_setup_card--title">Installing a Shop?</h4>
					<p class="etcpf_setup_card--subtitle">Please follow these steps to connect to you Etsy shop.</p>
					<div class="etcpf_setup_card_content">
						<ul>
							<li id="fetch_login_token">
								<?php if ( $stage < 2 ) { ?>
									<button href="#_" class="btn btn-primary btn-lg etsy-connector" onclick="etcpf_fetch_etsy_login_url()" >
										Fetch Etsy Login URL 
										<?php etcpf_get_gif_loader( 'etcpf_gif_loader', array( 'max-height' => '15px; margin-left: 4px' ) ); ?>
									</button>
								<?php } else { ?>
									<span>Login URL fetched</span>
									<span class="dashicons dashicons-yes"></span>
								<?php } ?>
							</li>

							<?php
							if ( $stage < 2 ) {
								$display = 'display:none';
							}
							?>
							<li id="redirect_to_login" style="<?php echo esc_html( $display ); ?>">
								<span class="dashicons dashicons-arrow-right"></span>
								<?php if ( $stage > 2 ) { ?>
									<span>Login Authenticated</span>
									<span class="dashicons dashicons-yes"></span>
								<?php } else { ?>
									<a href="<?php echo esc_url( $url ); ?>" class="btn btn-primary">Connect To Authenticate</a>
								<?php } ?>
							</li>

							<?php
							if ( $stage < 3 ) {
								$display = 'display:none';
							}
							?>
							<li id="authorize_token" style="<?php echo esc_html( $display ); ?>">
								<span class="dashicons dashicons-arrow-right"></span>
								<?php if ( $stage > 3 ) { ?>
									<span>Token Authorized</span>
									<span class="dashicons dashicons-yes"></span>
								<?php } else { ?>
									<button class="btn btn-primary etcpf_authorize_etsy_token_button"
										onclick="etcpf_authorize()">
										Authorize
										<?php etcpf_get_gif_loader( 'etcpf_gif_loader', array( 'max-height' => '15px; margin-left: 4px' ) ); ?>
									</button>
								<?php } ?>
							</li>
							<li id="show_myshop" style="display:none">
								<span class="dashicons dashicons-arrow-right"></span>
								<a href="?page=etsy-export-feed-configure" class="btn btn-primary">Show My
									Shop</a>
							</li>
							<?php
							if ( $stage < 4 ) {
								$display = 'display:none';
							}
							?>
							<li style="<?php echo esc_html( $display ); ?>">
								<span class="dashicons dashicons-arrow-right"></span>
								<?php if ( $stage > 4 ) { ?>
									<span>Shipping Address Added</span>
									<span class="dashicons dashicons-yes"></span>
								<?php } else { ?>
									<a class="btn btn-primary" href="?page=etsy-export-feed-configure&tab=settings&fetch_shipping=true">Add Shipping Details</a>
								<?php } ?>
							</li>
						</ul>
					</div>
				</div>
				<div class="etcpf_setup_card etcpf_setup_card--center"
					id="etcpf_setup_card_loader"
					<?php if ( ! $etcpf_hide_setup_step ) { ?>
						style="display:none"
					<?php } ?>
				>
					<h4 class="etcpf_setup_card--title" id="etcpf_setup_card_title">Hold on, we are getting things ready.</h4>
					<div class="etcpf_setup_card_body pt-5">
						<div class="spinner-border text-primary" style="width: 3rem; height: 3rem;" role="status">
						</div>
					</div>
				</div>
			</div>
		<?php if ( $stage < 5 ) { ?>
			<?php if ( $stage < 4 ) { ?>
				<div class="etcpf_stepper_wrapper etcpf_stepper_white" id="etcpf_setup_step_1"
					<?php if ( $etcpf_hide_setup_step ) { ?>
						style="display:none"
					<?php } ?>
				>
					<nav class="etcpf_stepper">
						<ol class="etcpf_stepper__nav">
							<li class="current etcpf_stepper__nav--item etcpf_item_first">
								<a href="#" onclick="etcpf_configure_etsy_shop_first()" class="etcpf_stepper__nav--button">
									<span class="etcpf_stepper__nav--name">
										Order Configuration
									</span>
								</a>
							</li>
							<li class="etcpf_stepper__nav--item etcpf_item_second">
								<a class="authorize_etsy_token etcpf_stepper__nav--button" href="#" onclick="etcpf_configure_etsy_shop_next()">
									<span class="etcpf_stepper__nav--name">
										Etsy Sync Configuration
									</span>
								</a>
							</li>
							<li class="etcpf_stepper__nav--item etcpf_item_third">
								<a class="etcpf_shipping etcpf_stepper__nav--button" href="#" onclick="etcpf_configure_etsy_shop_final()">
									<span class="etcpf_stepper__nav--name">
										Etsy Shop Connection
									</span>
								</a>
							</li>
						</ol>
					</nav>
				</div>
			<?php } ?>
				<div class="etcpf_setup_card" id="etcpf_setup_step_2"
					<?php if ( $etcpf_hide_setup_step ) { ?>
						style="display:none"
					<?php } ?>
				>
					<div id="etcpf_etsy-config-order-section">
						<h4 class="etcpf_setup_card--title fw-medium">Welcome on board !</h4>
						<p class="etcpf_setup_card--subtitle">Let's connect your Etsy shop first.</p>
						<p class="etcpf_setup_card--subtitle">
							Please select the suitable configuration for Order & Inventory sync and Attributes which will overwrite the Etsy product attributes by Woocommerce Product attributes.
							<br/>
							You can go to Settings tab later to ensure and customize the configurations.
						</p>
						<h5 class="etcpf_setup_card--title fw-medium">Order & Inventory Sync Selection</h5>
						<p class="etcpf_setup_card--subtitle">Please select the suitable configuration for Order and Inventory sync.
						</p>
						<div class="etcpf_setup_card_content">
							<div class="etcpf_setup_card_checklist">
								<form class="row gy-3 etcpf_setup_card_detail">
									<div class="col-12">
										<div class="form-check">
											<input class="form-check-input" type="checkbox" id="etcpf_sync_inventory" checked="checked">
											<label class="form-check-label" for="etcpf_sync_inventory">
												Enable Inventory Sync
											</label>
										</div>
									</div>
									<div class="col-12">
										<div class="form-check">
											<input class="form-check-input" type="checkbox" id="etcpf_sync_inventory_from_parent">
											<label class="form-check-label" for="etcpf_sync_inventory_from_parent">
												Deduct product level inventory (if stock management not enabled for variations)
											</label>
										</div>
									</div>
									<div class="col-11 mt-3">
										<label class="form-label" for="etcpf_order_fetch_interval">
											Set Order Fetch Interval :
										</label>
										<select id="etcpf_order_fetch_interval" class="form-select">
											<option value="every_minute">Every Minute</option>
											<option value="five_min">Five Minute</option>
											<option value="ten_min">Ten Minutes</option>
											<option value="fifteen_min">Fifteen Minutes</option>
											<option selected="selected" value="thirty_min">Thirty Minutes</option>
											<option value="three_hours">Three Hours</option>
											<option value="six_hours">Six Hours</option>
											<option value="twelve_hours">Twelve Hours</option>
											<option value="daily">Daily</option>
										</select>
									</div>
								</form>
							</div>
						</div>
						<div class="etcpf_setup_card_footer">
							<button href="#_" class="btn btn-primary btn-lg etsy-connector" 
								onclick="etcpf_configure_etsy_shop_next()" >
								Procced to next step
							</button>
						</div>
					</div>

					<div id="etcpf_etsy-config-sync-section" style="display: none;">
						<a href="#_" class="link-text link-text--arrow etsy-connector mb-3 d-inline-block" 
							onclick="etcpf_configure_etsy_shop_first()" >
							<span class="etcpf_arrow-left">&#8592;</span> &nbsp; Previous step
						</a>
						<h4 class="etcpf_setup_card--title fw-medium">Etsy products update by WooCommerce products</h4>
						<p class="etcpf_setup_card--subtitle">
							All the attributes you have selected below will overwrite the Etsy products once you update the products in WooCommerce.</br>
							If you uncheck the options it will prevent the update and help you maintain the difference in the two sites.
						</p>
						<div class="etcpf_setup_card_content">
							<div class="etcpf_setup_card_checklist">
								<form class="row gy-3 etcpf_setup_card_detail">
									<div class="col-12">
										<div class="form-check">
											<input class="form-check-input" type="checkbox" name="title_sync" id="etcpf_sync_title">
											<label class="form-check-label" for="etcpf_sync_title">
												Overwrite Etsy Product title by WooCommerce Product title
											</label>
										</div>
									</div>
									<div class="col-12">
										<div class="form-check">
											<input class="form-check-input" type="checkbox" name="description_sync" id="etcpf_sync_description">
											<label class="form-check-label" for="etcpf_sync_description">                                            
												Overwrite Etsy Product description by WooCommerce Product description
											</label>
										</div>
									</div>
									<div class="col-12">
										<div class="form-check">
											<input class="form-check-input" type="checkbox" name="price_sync" id="etcpf_sync_price">
											<label class="form-check-label" for="etcpf_sync_price">
												Overwrite Etsy Product price by WooCommerce Product price
											</label>
										</div>
									</div>
									<div class="col-12">
										<div class="form-check">
											<input class="form-check-input" type="checkbox" name="tags_sync" id="etcpf_sync_tags">
											<label class="form-check-label" for="etcpf_sync_tags">
												Update Etsy Product tags by WooCommerce Product tags
											</label>
										</div>
									</div>
									<div class="col-12">
										<div class="form-check">
											<input class="form-check-input" type="checkbox" name="materials_sync" id="etcpf_sync_materials">
											<label class="form-check-label" for="etcpf_sync_materials">
												Overwrite Etsy Product materials by WooCommerce Product materials
											</label>
										</div>
									</div>
									<div class="col-12">
										<div class="form-check">
											<input class="form-check-input" type="checkbox" name="images_sync" id="etcpf_sync_images">
											<label class="form-check-label" for="etcpf_sync_images">
												Overwrite Etsy Product images by WooCommerce Product images
											</label>
										</div>
									</div>
								</form>
							</div>
						</div>
						<div class="etcpf_setup_card_footer">
							<button href="#_" class="btn btn-primary btn-lg etsy-connector" 
								onclick="etcpf_configure_etsy_shop_final()" >
								Proceed to final step
							</button>
						</div>
					</div>

					<div id="etcpf_etsy-connect-shop-section"  style="display: none;">
						<a href="#_" class="link-text link-text--arrow etsy-connector mb-3 d-inline-block" 
							onclick="etcpf_configure_etsy_shop_previous()" >
							<span class="etcpf_arrow-left">&#8592;</span> &nbsp; Previous step
						</a>
						<h4 class="etcpf_setup_card--title fw-medium">Lets Connect the Etsy Shop !</h4>
						<p class="etcpf_setup_card--subtitle">
						You're connecting the Etsy store with the configurations you’ve selected. You can go to the settings tab to ensure everything is chosen according to your need.
						</p>
						<div class="etcpf_setup_card_footer">
							<button href="#_" id="etcpf_configure_etsy_shop_connect_button" class="btn btn-primary btn-lg etsy-connector" 
								onclick="etcpf_configure_etsy_shop_connect()" >
								Connect your Etsy Shop  
								<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true" style="display: none;"></span>
							</button>
						</div>
					</div>
				</div>
			<?php } elseif ( $stage >= 5 ) { ?>
			<div id="postbox-container-3" class="postbox-container" style="width:100%;">
						<?php if ( is_array( $cpf_shop ) && isset( $cpf_shop[0] ) ) { ?>
							<?php $shop = $cpf_shop[0]; ?>
					<div class="etcpf_card etcpf_table_card">
						<div class="etcpf_card_header">
							<h4>Shop Details</h4>
						</div>
						<div class="etcpf_card_body">
							<div class="table-responsive">
								<table class="table etcpf_table">
									<tr>
										<th>Shop Name</th>
										<th>Name</th>
										<th>Action</th>
									</tr>
									<tr>
										<td><?php echo esc_html( $shop->shop_name ); ?></td>
										<td><?php echo esc_html( $shop->name ); ?></td>
										<td>
											<div class="etcpf_table_action">
												<a href="#" class="etcpf_text_danger" onclick="etcpf_call_out_for_purge_data()">Purge Data</a>&nbsp; | &nbsp;
												<a href="#" onclick="etcpf_deleteEtsyShop()">Remove Shop</a>
											</div>
										</td>
									</tr>
								</table>
							</div>
						</div>
				<?php } ?>
			</div>
			<?php } ?>
		</div>
	</div>
</div>
<script>
	jQuery("#etcpf_sync_inventory").click(function () {
		if (jQuery("#etcpf_sync_inventory").is(":checked")) {
			jQuery("#etcpf_sync_inventory_from_parent").attr("disabled", false);
		} else {
			jQuery("#etcpf_sync_inventory_from_parent").prop("checked", false);
			jQuery("#etcpf_sync_inventory_from_parent").attr("disabled", true);
		}
	});
</script>
