<?php

require_once dirname(__FILE__) . '/migration_includes.php';

$etcpf_db_version         = $GLOBALS['etcpf_db_version'];
$etcpf_current_db_version = __get_option( 'etcpf_current_db_version' );

if ( ! function_exists( 'etcpf_db_upgrade_all' ) ) :
	function etcpf_db_upgrade_all( $etcpf_current_db_version, $etcpf_db_version ) {

		if ( get_option( 'etcpf_db_upgraded' ) == 'true' ) {
			update_option( 'etcpf_db_upgraded', 'false' );
		};

		// now compare the current db version and run the upgrades as per the requirement
//		if ( $etcpf_current_db_version < 1.1 ) {
//			check_db_error( etcpf_db_upgrade_test_386() );
//		}

		update_option( 'etcpf_current_db_version', $etcpf_db_version );
		update_option( 'etcpf_db_upgraded', 'true' );
		wp_send_json_success( 'done', 200 );

	}
endif;

if ( ! function_exists( 'check_db_error' ) ) :
	function check_db_error( $result ): void {
		if ( ! $result ) {
			wp_send_json_error( 'error', 400 );
		}
	}
endif;

etcpf_db_upgrade_all( $etcpf_current_db_version, $etcpf_db_version );