(function(jQuery){
  let ajaxLoader = jQuery('#ajax-loader-cat-import'),
    seperator = jQuery('#select-separator').val(),
    sorted = [];

  var $sortable = jQuery("#tablelist > tbody");
  $sortable.sortable({
    stop: function (event, ui) {
      var parameters = $sortable.sortable("toArray");
      sorted = parameters;
      jQuery('#sorted-attribute').val(sorted);
      etcpf_formExample(parameters);
    }
  });

  jQuery("#select-display").change(function () {
    if (jQuery('#no-data-td').length) {
      jQuery('#no-data-td').closest('tr').remove();
    }
    jQuery("#tablelist").show();
    let attribute = jQuery(this).val();

    if(attribute === '0'){
      return false;
    }
    if (typeof jQuery('#' + attribute.replace(/ /g, '_space_')).html() !== 'undefined') {
      alert("This attibute "+attribute+" is already on list");
      jQuery("#select-display").prop("selectedIndex", 0);
      return false;
    }

    jQuery('#attribute-selection-option-'+attribute).attr('disabled','disabled');

    let html = '<tr id="' + attribute.replace(/ /g, '_space_') + '" class="ui-sortable-handle">' +
      '<td><img src="' + ETCPF.plugins_url + "images/move.png" + '" id="drag" /></td>' +
      '<td><input class="variation-attribute-prefix" type="text" placeholder="eg: sup" name="prefix_' + attribute.replace(/ /g, '_space_') + '" value=""></td>' +
      '<td>' + attribute + '</td>' +
      '<td><input class="variation-attribute-suffix" type="text" placeholder="eg: dup" name="suffix_' + attribute.replace(/ /g, '_space_') + '" value=""></td>' +
      '<td><button type="button" data-attribute="' + attribute.replace(/ /g, '_space_') + '" data-id="0" class="button deletebtn">Remove</button></td>' +
      '</tr>';
    jQuery("#tablelist tbody").append(html);
    etcpf_updateSortable();
  });

  jQuery(document).on('click', '.deletebtn', function (event) {
    event.preventDefault();

    let r=confirm("Are you sure you want to remove this attribute ?");
    if(r===false){
      return false;
    }

    ajaxLoader.show();

    let attribute = jQuery(this).attr('data-attribute');
    jQuery('#attribute-selection-option-'+attribute).removeAttr('disabled');
    jQuery("#select-display").prop("selectedIndex", 0);

    selector = this;
    let id = jQuery(this).attr('data-id');
    if (id > 0) {
      payload = {
        action: 'exportfeed_etsy',
        feedpath: ETCPF.cmd_profiling_ajax_handler,
        security: ETCPF.ETCPF_nonce,
        perform: 'deleteattributes',
        id: id
      };

      etcpf_globalAjax(this, payload, function (err, res) {
        if (!res.success) {
          alert("There was some problem please try again later");
        } else {
          jQuery(selector).closest('tr').remove();
          etcpf_updateSortable();
        }
        jQuery('#ajax-loader-cat-import').hide();
      });
    } else {
      jQuery(this).closest('tr').remove();
      jQuery('#ajax-loader-cat-import').hide();
      etcpf_updateSortable();
    }

  });


  jQuery(document).on('input', '.variation-attribute-prefix , .variation-attribute-suffix', function (event) {
    event.preventDefault();
    etcpf_updateSortable();
  });

  var etcpf_updateSortable = function () {
    $sortable = jQuery("#tablelist > tbody");
    $sortable.trigger('sortupdate');
    var parameters = $sortable.sortable("toArray");
    jQuery('#sorted-attribute').val(parameters);
    if(parameters.length >= 2) etcpf_formExample(parameters);
  };

  jQuery(document).on('input', '#select-separator', function(){
    seperator = jQuery('#select-separator').val();
    etcpf_updateSortable();
  });

  var etcpf_formExample = function (parameters) {
    let attributeFormed = '',
      valueFormed = '';

    for( var i in parameters){
      let prefix = jQuery("[name=prefix_"+parameters[i]+"]").val(),
        suffix = jQuery("[name=suffix_"+parameters[i]+"]").val();
      attributeFormed += parameters[i].replace(/_space_/g, ' ');
      valueFormed += prefix + parameters[i].replace(/_space_/g, ' ') + ' value' + suffix;
      if(parameters.length-1 > i){
        attributeFormed += seperator;
        valueFormed += seperator;
      }
    }

    let variations = '<tr><td>';
    variations += attributeFormed;
    variations += '</td></tr>';
    let result = '<tr><td>';
    result += valueFormed;
    result += '</td></tr>';

    jQuery('#variation-body').html(variations);
    jQuery('#result-body').html(result);
  };

  jQuery("[name=profile_name]").on("input", function(event){
    event.preventDefault();
    jQuery('#profile-submitter').removeAttr('disabled');
    if(jQuery(this).val() === jQuery("[name=current_profile_name").val()){
      jQuery(".validation-error").remove();
      return true;
    }

    let payload = {
      action: 'exportfeed_etsy',
      feedpath: ETCPF.cmd_profiling_ajax_handler,
      security: ETCPF.ETCPF_nonce,
      data: {'profile_name':jQuery(this).val()},
      perform: 'validateprofile',
    };

    etcpf_globalAjax(this, payload, function(err, data){
      if(err){
        alert(err)
      }else{
        if(data.success===false){
          jQuery('#profile-submitter').attr('disabled', true);
          jQuery("[name=profile_name").focus();
          if(jQuery('.validation-error').html()){
            jQuery(".validation-error").html(data.data.message);
          }else{
            jQuery("[name=profile_name").after('<div class="validation-error col-md-4">'+data.data.message+'</div>');
          }
          jQuery(".validation-error").css({'color':'red'})
        }else{
          jQuery('#profile-submitter').attr('disabled', false);
          jQuery(".validation-error").remove();
        }
      }
    });
  });

  jQuery('#profile-submitter').on('click', function(event){
    let Attributes = jQuery('#sorted-attribute').val();
    if(Attributes.length <= 0){
      alert("At least one variation attribute must be selected.");
      return false;
    }else{
      return true;
    }
  })

})(jQuery)
